﻿EveryQuest = LibStub("AceAddon-3.0"):NewAddon("EveryQuest", "AceConsole-3.0", "AceEvent-3.0", "AceHook-3.0")
local addon = EveryQuest
local Quixote = LibStub("LibQuixote-2.0")
local L = LibStub("AceLocale-3.0"):GetLocale("EveryQuest")
local db, dbpc
local faction, zoneid, zonegroup, clickedID, oldprofile
EveryQuestData = {}
local questdisplay = {}
local TextColors = {}
TextColors["s-1"] = { r = 1.00, g = 0.00, b = 0.00, font = EQFont_Failed };
TextColors["s0"] = { r = 1.00, g = 1.00, b = 0, font = EQFont_Progress };
TextColors["s1"] = { r = 0.00, g = 1.00, b = 0.00, font = EQFont_Complete };
TextColors["s2"] = { r = 0.0, g = 0.807, b = 0.019, font = EQFont_TurnedIn };
TextColors["unknown"]	= { r = 1, g = 1, b = 1, font = EQFont_Unknown };

local SECOND = 1
local MINUTE = 60
local HOUR = 3600
local DAY = 86400

local options = { 
    type='group',
	name = "EveryQuest",
	get = function(info) return db[ info[#info] ] end,
	set = function(info, value) db[ info[#info] ] = value end,
    args = {
		intro = {
			order = 1,
			type = "description",
			name = L["EQ_DESC"],
		},
		track = {
			type = 'toggle',
			name = L["Track Zone"],
			desc = L["Track zone changes and update the EveryQuest list for that zone"],
			width = "double",
		},
		debug = {
			type = 'toggle',
			name = L["Show Debugging Messages"],
			desc = L["Show Debugging Messages - *WARNING* Spams your default chat frame"],
			--set = function(newval) db.profile.debug = not db.profile.debug end,
			--get = function() return db.profile.debug end,
			width = "double",
		},
		upgrade = {
			type = 'execute',
			name = L["Upgrade DB"],
			desc = L["Upgrade the Database from the old format"],
			func = function()
				StaticPopup_Show ("EVERYQUEST_UPGRADEDB")
			end,
			order = -2,
		},
		purgeold = {
			type = 'execute',
			name = L["Purge Old data"],
			desc = L["Purge Old database data, generally used after running upgrade"],
			func = function()
				StaticPopup_Show ("EVERYQUEST_PURGEOLD")
			end,
			order = -2,
		}
    },
}
local zonemenu = { -- Dropdown Zone list
	["Eastern Kingdoms"] = {
		{36,"Alterac Mountains"},
		{45,"Arathi Highlands"},
		{3,"Badlands"},
		{25,"Blackrock Mountain"},
		{4,"Blasted Lands"},
		{46,"Burning Steppes"},
		{279,"Dalaran"},
		{41,"Deadwind Pass"},
		{2257,"Deeprun Tram"},
		{1,"Dun Morogh"},
		{10,"Duskwood"},
		{139,"Eastern Plaguelands"},
		{12,"Elwynn Forest"},
		{3430,"Eversong Woods"},
		{3433,"Ghostlands"},
		{267,"Hillsbrad Foothills"},
		{1537,"Ironforge"},
		{4080,"Isle of Quel'Danas"},
		{38,"Loch Modan"},
		{44,"Redridge Mountains"},
		{51,"Searing Gorge"},
		{3487,"Silvermoon City"},
		{130,"Silverpine Forest"},
		{1519,"Stormwind City"},
		{33,"Stranglethorn Vale"},
		{8,"Swamp of Sorrows"},
		{47,"The Hinterlands"},
		{85,"Tirisfal Glades"},
		{1497,"Undercity"},
		{28,"Western Plaguelands"},
		{40,"Westfall"},
		{11,"Wetlands"},
	},
	["Kalimdor"] = {
		{331,"Ashenvale"},
		{16,"Azshara"},
		{3524,"Azuremyst Isle"},
		{3525,"Bloodmyst Isle"},
		{148,"Darkshore"},
		{1657,"Darnassus"},
		{405,"Desolace"},
		{14,"Durotar"},
		{15,"Dustwallow Marsh"},
		{361,"Felwood"},
		{357,"Feralas"},
		{493,"Moonglade"},
		{215,"Mulgore"},
		{1637,"Orgrimmar"},
		{1377,"Silithus"},
		{406,"Stonetalon Mountains"},
		{440,"Tanaris"},
		{141,"Teldrassil"},
		{17,"The Barrens"},
		{3557,"The Exodar"},
		{400,"Thousand Needles"},
		{1638,"Thunder Bluff"},
		{1216,"Timbermaw Hold"},
		{490,"Un'Goro Crater"},
		{618,"Winterspring"},
	},
	["Outland"] = {
		{3522,"Blade's Edge Mountains"},
		{3483,"Hellfire Peninsula"},
		{3518,"Nagrand"},
		{3523,"Netherstorm"},
		{3520,"Shadowmoon Valley"},
		{3703,"Shattrath City"},
		{3679,"Skettis"},
		{3519,"Terokkar Forest"},
		{3521,"Zangarmarsh"},
	},
	["Northrend"] = {
		{3537,"Borean Tundra"},
		{4024,"Coldarra"},
		{4395,"Dalaran"},
		{65,"Dragonblight"},
		{394,"Grizzly Hills"},
		{495,"Howling Fjord"},
		{210,"Icecrown"},
		{3711,"Sholazar Basin"},
		{67,"The Storm Peaks"},
		{4197,"Wintergrasp"},
		{66,"Zul'Drak"},
	},
	["Dungeons"] = {
		{4494,"Ahn'kahet: The Old Kingdom"},
		{3790,"Auchenai Crypts"},
		{3477,"Azjol-Nerub"},
		{719,"Blackfathom Deeps"},
		{1584,"Blackrock Depths"},
		{1583,"Blackrock Spire"},
		{1941,"Caverns of Time"},
		{3905,"Coilfang Reservoir"},
		{2557,"Dire Maul"},
		{4196,"Drak'Tharon Keep"},
		{133,"Gnomeregan"},
		{4375,"Gundrak"},
		{4272,"Halls of Lightning"},
		{4264,"Halls of Stone"},
		{3562,"Hellfire Ramparts"},
		{4095,"Magisters' Terrace"},
		{3792,"Mana-Tombs"},
		{2100,"Maraudon"},
		{2367,"Old Hillsbrad Foothills"},
		{2437,"Ragefire Chasm"},
		{722,"Razorfen Downs"},
		{491,"Razorfen Kraul"},
		{796,"Scarlet Monastery"},
		{2057,"Scholomance"},
		{3791,"Sethekk Halls"},
		{3789,"Shadow Labyrinth"},
		{209,"Shadowfang Keep"},
		{2017,"Stratholme"},
		{4100,"Stratholme Past"},
		{1417,"Sunken Temple"},
		{3845,"Tempest Keep"},
		{3846,"The Arcatraz"},
		{2366,"The Black Morass"},
		{3713,"The Blood Furnace"},
		{3847,"The Botanica"},
		{1581,"The Deadmines"},
		{3849,"The Mechanar"},
		{4120,"The Nexus"},
		{4228,"The Oculus"},
		{3714,"The Shattered Halls"},
		{3717,"The Slave Pens"},
		{3715,"The Steamvault"},
		{717,"The Stockade"},
		{3716,"The Underbog"},
		{4415,"The Violet Hold"},
		{1337,"Uldaman"},
		{206,"Utgarde Keep"},
		{1196,"Utgarde Pinnacle"},
		{718,"Wailing Caverns"},
		{978,"Zul'Farrak"},
	},
	["Raids"] = {
		{2677,"Blackwing Lair"},
		{3606,"Hyjal Summit"},
		{2562,"Karazhan"},
		{3836,"Magtheridon's Lair"},
		{2717,"Molten Core"},
		{3456,"Naxxramas"},
		{2159,"Onyxia's Lair"},
		{3429,"Ruins of Ahn'Qiraj"},
		{3428,"Temple of Ahn'Qiraj"},
		{3840,"The Black Temple"},
		{3842,"The Eye"},
		{3805,"Zul'Aman"},
		{19,"Zul'Gurub"},
	},
	["Classes"] = {
		{-372,"Death Knight"},
		{-263,"Druid"},
		{-261,"Hunter"},
		{-161,"Mage"},
		{-141,"Paladin"},
		{-262,"Priest"},
		{-162,"Rogue"},
		{-82,"Shaman"},
		{-61,"Warlock"},
		{-81,"Warrior"},
	},
	["Professions"] = {
		{-181,"Alchemy"},
		{-121,"Blacksmithing"},
		{-304,"Cooking"},
		{-201,"Engineering"},
		{-324,"First Aid"},
		{-101,"Fishing"},
		{-24,"Herbalism"},
		{-371,"Inscription"},
		{-373,"Jewelcrafting"},
		{-182,"Leatherworking"},
		{-264,"Tailoring"},
	},
	["Battlegrounds"] = {
		{-25,"All"},
		{3358,"Arathi Basin"},
		{2597,"Alterac Valley"},
		{3820,"Eye of the Storm"},
		{3277,"Warsong Gulch"},
	},
	["Seasonal"] = {
		{-370,"Brewfest"},
		{-1002,"Children's Week"},
		{-364,"Darkmoon Faire"},
		{-1003,"Hallow's End"},
		{-1005,"Harvest Festival"},
		{-1004,"Love is in the Air"},
		{-366,"Lunar Festival"},
		{-369,"Midsummer Fire Festival"},
		{-1006,"New Year's Eve"},
		{-1001,"Winter Veil"},
	},
	["Miscellaneous"] = {
		{-365,"Ahn'Qiraj War Effort"},
		{-1,"Epic"},
		{-344,"Legendary"},
		{-367,"Reputation"},
		{-368,"Scourge Invasion"},
		{-22,"Seasonal"},
	},
}
StaticPopupDialogs["EVERYQUEST_UPGRADEDB"] = {
  text = L["EveryQuest has deteched an out of date database (resulting from a version upgrade), click Yes to attempt to upgrade. This may take a moment. You can upgrade later using /everyquest upgrade"],
  button1 = L["Upgrade"],
  button2 = L["Cancel"],
  OnAccept = function()
	  addon:Debug("EVERYQUEST_UPGRADEDB: OnAccept")
	  addon:UpgradeDB(oldprofile)
  end,
  OnCancel = function()
	dbpc.upgradeshow = true
  end,
  timeout = 0,
  whileDead = 1,
  hideOnEscape = 1
};
StaticPopupDialogs["EVERYQUEST_PURGEOLD"] = {
  text = L["EveryQuest has finished upgrading the Database, at this time you can purge the old database. This action is irreversible. You can clear the database later using /everyquest purgeold"],
  button1 = L["Purge"],
  button2 = L["Cancel"],
  OnAccept = function()
	  addon:Debug("EVERYQUEST_PURGEOLD: OnAccept")
	  dbpc.QuestHistory = nil
	  EveryQuestDBPC = nil
  end,
  timeout = 0,
  whileDead = 1,
  hideOnEscape = 1
};

-- Debug Function
-- #NODOC
--[[function addon:Print(text)
    DEFAULT_CHAT_FRAME:AddMessage(tostring(text))
end]]
function addon:Print(text)
    DEFAULT_CHAT_FRAME:AddMessage("EveryQuest: " ..tostring(text))
end
function addon:Error(string)
	self:Print("|cffff0000"..string.."|r")
end
function addon:Debug(string)
	if self.db.profile.debug then  
		self:Print(string)
	end
end
local function concat(var)
	if type(var) == "number" then
		return var
	elseif type(var) == "string" then
		return var
	elseif type(var) == "table" then
		return "table"
	else
		return "nil"
	end
end

-- Addon functions

function addon:OnInitialize()
	---------------------------------------------------------------------
	--- Setup Databases, Options
    self.db = LibStub("AceDB-3.0"):New("EQ2DB", {
			profile = {
				debug = false,
				view = "zone",
			},
		}, "global")
	db = self.db.profile
	self.dbpc = LibStub("AceDB-3.0"):New("EQ2DBPC", {
			profile = {
		        zoneid = nil,
				zonegroup = nil,
				history = {},
		    },
		}, "global")
	dbpc = self.dbpc.profile
	LibStub("AceConfig-3.0"):RegisterOptionsTable("EveryQuest", options)
    self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("EveryQuest", "EveryQuest")
    self:RegisterChatCommand("everyquest", function() addon:ShowConfig() end)
	
	---------------------------------------------------------------------
	--- Handle Migration
	if EveryQuestDBPC ~= nil then
		for profilename,profile in pairs(EveryQuestDBPC) do 
			self:Debug(concat(profilename) .. " - " .. concat(profile))
			if profile.history ~= nil and not dbpc.copied then
				self:Debug("history is not nil, single upgrade copy")
				if dbpc.history == nil then
					dbpc.history = {}
				end
				if dbpc.history == nil then
					dbpc.history = profile.history
					dbpc.copied = true
					profile.history = nil
				end
			end
			if profile.QuestHistory ~= nil and not dbpc.upgraded then
				self:UpgradeDB(profile)
				self:Debug("QuestHistory is not nil, double upgrade")
			end
		end
	end
	
	if dbpc.QuestHistory ~= nil and dbpc.upgradeshow ~= true then
		StaticPopup_Show ("EVERYQUEST_UPGRADEDB")
		oldprofile = nil
	end
	
	---------------------------------------------------------------------
	--- Setup Frames
	EveryQuestTitleText:SetText(L["EveryQuest Log"])
	BINDING_HEADER_eqTITLE = L["EveryQuest"]
	BINDING_NAME_eqTOGGLE = L["Toggle Frame"]
	addon.frames = {}
	-- Create the "EQ" toggle button for the questlog frame
	addon.frames.Show = CreateFrame("Button",nil, QuestLogFrame, "UIPanelButtonTemplate")
	addon.frames.Show:SetWidth(28)
	addon.frames.Show:SetHeight(18)
	addon.frames.Show:SetText("EQ")
	addon.frames.Show:Show()
	addon.frames.Show:ClearAllPoints()
	addon.frames.Show:SetPoint("TOPLEFT",QuestLogFrame, "TOPLEFT",75,-15)
	addon.frames.Show:SetScript("OnClick", function() addon:Toggle()	end)
	
	-- Create the List toggle button to toggle between quest history and quests in a category
	addon.frames.Toggle = CreateFrame("Button",nil, EveryQuestFrame, "UIPanelButtonTemplate")
	addon.frames.Toggle:SetWidth(122)
	addon.frames.Toggle:SetHeight(21)
	addon.frames.Toggle:SetText(" ")
	addon.frames.Toggle:Show()
	addon.frames.Toggle:ClearAllPoints()
	addon.frames.Toggle:SetPoint("BOTTOMLEFT",EveryQuestFrame, "BOTTOMLEFT",18,5)
	addon.frames.Toggle:SetScript("OnClick", function() addon:List("toggle") end)

	
	local button = CreateFrame("Button", "EveryQuestTitle1", EveryQuestFrame,"EveryQuestTitleButtonTemplate")
	button:SetID(1)
	button:Hide()
	button:ClearAllPoints()
	button:SetPoint("TOPLEFT", EveryQuestFrame, "BOTTOMLEFT", 19, -75)
	for i = 2, 27 do
		button = CreateFrame("Button", "EveryQuestTitle" .. i, EveryQuestFrame,"EveryQuestTitleButtonTemplate")
		button:SetID(i)
		button:Hide()
		button:ClearAllPoints()
		button:SetPoint("TOPLEFT", getglobal("EveryQuestTitle" .. (i-1)), "BOTTOMLEFT", 0, 1)
	end
	
	-- Zone Menu creation
	addon.frames.Menu = CreateFrame("Frame", "EQ_Menu", EveryQuestFrame, "UIDropDownMenuTemplate")
	addon.frames.Menu:Show()
	EQDropdown = addon.frames.Menu
	addon.frames.Menu:ClearAllPoints()
	addon.frames.Menu:SetPoint("TOPLEFT",EveryQuestFrame, "TOPLEFT", 115,-40)
	UIDropDownMenu_SetWidth(EQ_Menu, 150, 0)
	UIDropDownMenu_SetButtonWidth(EQ_Menu, 20)
	EQ_MenuButton:SetScript("OnClick", function(self, button, down)
		ToggleDropDownMenu(1, nil, EveryQuest_ZoneMenu, self:GetName(), 0, 0)
	end)
	
	UIDropDownMenu_SetText(EQDropdown, L["-- Select --"])
		
	-- Load the saved view
	addon:List(db.view)
	
	local f = UnitFactionGroup("player")
	if f == "Alliance" then
		faction = 1
	else
		faction = 2
	end
	
	self:RegisterEvent("PLAYER_LOGIN")
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	tinsert(UISpecialFrames,"EveryQuestFrame");
end

function addon:ZONE_CHANGED_NEW_AREA()
	--self:Debug("ZONE_CHANGED_NEW_AREA - " .. GetRealZoneText())
	if db.track then
		z, g = self:GetZoneId(GetRealZoneText())
		if z ~= nil then
			zoneid = z
		end
		if g ~= nil then
			zonegroup = g
		end
		self:Debug("Zone Changed ("..GetRealZoneText()..") - zoneid = " .. concat(zoneid) .. " zonegroup = " .. concat(zonegroup))
		self:UpdateFrame()
	end
end

function addon:GetZoneId(category)
	for k,v in pairs(zonemenu) do -- for each top level category
		if k == category then
			return nil, k
		else
			for ak,av in pairs(v) do -- for each category
				if av[2] == category then
					return av[1], k
				end
			end
		end
	end
end

function addon:GetCategory(zid)
	for k,v in pairs(zonemenu) do -- for each top level category
		for ak,av in pairs(v) do -- for each category
			if av[1] == zid then
				return k, av[2]
			end
		end
	end
end

-- menu create function
do
	local info = {}
	local EveryQuest_ZoneMenu = CreateFrame("Frame", "EveryQuest_ZoneMenu")
	EveryQuest_ZoneMenu.displayMode = "MENU"
	EveryQuest_ZoneMenu.point = "TOPRIGHT"
	--/run DropDownList1:SetPoint("TOPRIGHT", "EQ_MenuButton", "BOTTOMRIGHT",0,0)
	EveryQuest_ZoneMenu.relativeTo = "EQ_MenuButton"
	EveryQuest_ZoneMenu.relativePoint = "BOTTOMRIGHT"
	EveryQuest_ZoneMenu.initialize = function(self, level)
		if not level then return end
		--sort(zonemenu, function(a, b) addon:Debug(a .. " - " .. b) return true end)
		for k in pairs(info) do info[k] = nil end
		if (level == 1) then
			for key in pairs(zonemenu) do
				info.hasArrow = true; -- creates submenu
				info.notCheckable = true;
				info.text = key;
				info.value = key;
				UIDropDownMenu_AddButton(info, level);
			end -- for key, subarray
			-- Close menu item
			info.text         = CLOSE
			info.func         = function() CloseDropDownMenus() end
			info.checked      = nil
			info.arg1         = nil
			info.notCheckable = 1
			info.hasArrow = nil
			UIDropDownMenu_AddButton(info, level)
		end -- if level 1
		if level == 2 then
			--addon:Debug("level 2")
			curzone = zonemenu[UIDROPDOWNMENU_MENU_VALUE]
			--sort(curzone, function(a, b) addon:Debug(a .. " - " .. b) return true end)
			info.isTitle      = 1
			info.text         = UIDROPDOWNMENU_MENU_VALUE
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			info.disabled     = nil
			info.isTitle      = nil
			info.notCheckable = nil
			for key, value in pairs(curzone) do
				info.hasArrow = nil; -- creates submenu
				info.text = value[2];
				info.value = value[1];
				info.tooltipTitle = key -- Title of the tooltip shown on mouseover
				info.tooltipText = "tooltiptext" -- Text of the tooltip shown on mouseover, return the current amount of completed quests out of the total available to that faction
				info.func = function()
					zoneid = value[1]
					zonegroup = UIDROPDOWNMENU_MENU_VALUE
					CloseDropDownMenus()
					addon:UpdateFrame()
				end
				info.checked = function() if zoneid == value[1] then return true end end  --  Check the button if true or function returns true
				UIDropDownMenu_AddButton(info, level);
			end -- for key, subarray
			-- Close menu item
			info.text         = CLOSE
			info.func         = function() CloseDropDownMenus() end
			info.checked      = nil
			info.arg1         = nil
			info.tooltipTitle = nil
			info.tooltipText = nil
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
		end
	end
end

do
	local info = {}
	local statues = {
		{name = L["Turned In"],	status = 2},
		{name = L["Completed"], status = 1},
		{name = L["In Progress"], status = 0},
		{name = L["Abandoned"], status = -1,},
		{name = L["Failed"], status = -1},
	}
	local EveryQuest_QuestMenu = CreateFrame("Frame", "EveryQuest_QuestMenu")
	EveryQuest_QuestMenu.displayMode = "MENU"
	EveryQuest_QuestMenu.initialize = function(self, level)
		if not level then return end
		for k in pairs(info) do info[k] = nil end
		if (level == 1) then
			for key, value in pairs(statues) do
				info.checked = function() return addon:GetStatus(clickedID, value.status) end
				info.func = function() addon:UpdateStatus(clickedID, value.status) end
				info.text = value.name;
				UIDropDownMenu_AddButton(info, level);
			end -- for key, subarray
			-- Close menu item
			info.text         = CLOSE
			info.func         = function() CloseDropDownMenus() end
			info.checked      = nil
			info.arg1         = nil
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
		end -- if level 1
	end
end

function addon:OnEnable()
	Quixote.RegisterCallback(self, "Quest_Abandoned", "Abandon")
	Quixote.RegisterCallback(self, "Quest_Gained", "Gained")
	Quixote.RegisterCallback(self, "Quest_Complete", "Complete")
	Quixote.RegisterCallback(self, "Quest_Failed", "Failed")
	Quixote.RegisterCallback(self, "Quest_Lost", "Lost")
	addon:RawHookScript(QuestFrameCompleteQuestButton, "OnClick", "CompleteQuestButton")
end

function addon:OnDisable()
	Quixote:UnregisterAll()
	addon:UnhookAll()
end

function addon:Toggle()
	if EveryQuestFrame:IsShown() then
		EveryQuestFrame:Hide()
	else
		EveryQuestFrame:Show()	
		self:UpdateFrame()
	end
end
function addon:OnShow()
	if dbpc.posx and dbpc.posy then
		EveryQuestFrame:ClearAllPoints()
		EveryQuestFrame:SetPoint("TOPLEFT","UIParent", "BOTTOMLEFT", dbpc.posx, dbpc.posy)
	end
end
function addon:SavePosition()
	local Left = EveryQuestFrame:GetLeft()
	local Top = EveryQuestFrame:GetTop()
	if Left and Top then
		dbpc.posx = Left
		dbpc.posy = Top
	end
end

function addon:UpgradeDB(profile)
	local toupgrade
	if profile.QuestHistory ~= nil then
		toupgrade = profile.QuestHistory
	elseif dbpc.QuestHistory ~= nil then
		toupgrade = dbpc.QuestHistory
	else
		return
	end
	if toupgrade then
		local category, questname, quest, zone
		for category,v in pairs(toupgrade) do
			--self:Debug(category)
			for questname, oldquest in pairs(v) do
				if questname ~= "Collapsed" then
					quest, zone = self:GetQuestData(nil, category, questname)
					if quest then
						self:Debug("|cffffff00UpgradeDB|r: qid:" .. concat(quest.id) .. ", zoneid:"..concat(zone))
						if dbpc.history[zone] == nil then
							dbpc.history[zone] = {}
						end
						if dbpc.history[zone][quest.id] == nil then
							dbpc.history[zone][quest.id] = {}
						end
						dbpc.history[zone][quest.id].id = quest.id
						if dbpc.history[zone][quest.id].status == nil then
							if oldquest.status ~= nil then
								dbpc.history[zone][quest.id].status = oldquest.status
							else
								dbpc.history[zone][quest.id].status = 2
							end
						end
						if oldquest.completed ~= nil and dbpc.history[zone][quest.id].completed == nil then
							dbpc.history[zone][quest.id].completed = oldquest.completed
						end
						if oldquest.abandoned ~= nil and dbpc.history[zone][quest.id].abandoned == nil then
							dbpc.history[zone][quest.id].abandoned = oldquest.abandoned
						end
					else
						self:Debug("|cffffff00UpgradeDB|r: Failed to get QID for: '" .. concat(questname) .. "' in " .. concat(category))
					end
				end
			end
		end
		dbpc.upgraded = true
		StaticPopup_Show ("EVERYQUEST_PURGEOLD")
	end
end

function addon:ShowConfig()
	InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
end

function addon:Abandon(event, title, uid)
	self:Debug("Abandon - " .. uid)
	local _, _, _, _, _, _, _, _, _, category = Quixote:GetQuestByUid(uid)
	local zone = EveryQuest:AddQuest(uid, category)
	if zone ~= false and zone ~= nil then
		self:Debug("QUEST_ABANDON - questid:"..concat(uid).." zoneid:"..concat(zone))
		dbpc.history[zone][uid].status = -1
		dbpc.history[zone][uid].abandoned = time()
		self:UpdateFrame()
	else
		self:Error("Abandon Quest: Unable to get Quest Information from DB")
	end
	
end

function addon:Gained(event, title, uid, objectives)
	self:Debug("Gained - " .. uid)
	local _, _, _, _, _, _, _, _, _, category = Quixote:GetQuestByUid(uid)
	local zone = self:AddQuest(uid, category)
	self:Debug("Quixote_Quest_Gained - questid:"..concat(uid).." zoneid:"..concat(zone))
	if zone ~= false and zone ~= nil then
		self:UpdateFrame()
	else
		self:Error("Gained Quest: Unable to get Quest Information from DB")
	end
end

function addon:Complete(event, title, uid)
	-- Complete as in completed all the objectives
	
	local _, _, _, _, _, _, _, _, _, category = Quixote:GetQuestByUid(uid)
	local zone = self:AddQuest(uid, category)
	
	if zone ~= false and zone ~= nil then
		--if dbpc.history[zone] then
			self:Debug("Complete - " .. concat(uid) .. " zoneid:"..concat(zone))
		--end
		dbpc.history[zone][uid].status = 1
		self:Debug("Quixote_Quest_Complete - questid:"..concat(uid).." zoneid:"..concat(zone))
		self:UpdateFrame()
	else
		self:Error("Complete Quest: Unable to get Quest Information from DB")
	end
end

function addon:Failed(event, title, uid)
	self:Debug("Failed - " .. uid)
	local _, _, _, _, _, _, _, _, _, category = Quixote:GetQuestByUid(uid)
	local zone = self:AddQuest(uid, category)
	if zone ~= false and zone ~= nil then
		dbpc.history[zone][uid].status = -1
		dbpc.history[zone][uid].failed = time()
		self:Debug("Quixote_Quest_Failed - questid:"..concat(uid).." zoneid:"..concat(zone))
		self:UpdateFrame()
	else
		self:Error("Failed Quest: Unable to get Quest Information from DB")
	end
end
function addon:Lost(event, title, uid, zone)
	self:Debug("Lost - " .. uid)
end

function addon:CompleteQuestButton()
	if ( QuestFrameRewardPanel.itemChoice == 0 and GetNumQuestChoices() > 0 ) then
		QuestChooseRewardError();
	else
		addon:TurnedIn(GetTitleText())
		GetQuestReward(QuestFrameRewardPanel.itemChoice);
		PlaySound("igQuestListComplete");
	end
end

function addon:TurnedIn(title)
	uid = Quixote:GetQuest(title)
	self:Debug("TurnedIn - " .. concat(uid))
	local _, _, _, _, _, _, _, _, _, category = Quixote:GetQuestByUid(uid)
	local zone, daily = self:AddQuest(uid, category)
	if zone ~= false and zone ~= nil then
		self:Debug("QuestTurnedIn - questid:"..concat(uid).." zoneid:"..concat(zone))
		dbpc.history[zone][uid].status = 2
		dbpc.history[zone][uid].completed = time()
		if daily then
			if dbpc.history[zone][uid].count ~= nil then
				dbpc.history[zone][uid].count = dbpc.history[zone][uid].count +1
			else
				dbpc.history[zone][uid].count = 1
			end
		end
		self:UpdateFrame()
	else
		self:Error("Turn In Quest: Unable to get Quest Information from DB")
	end
end

function addon:AddQuest(questid, category)
	if dbpc.history == nil then
		dbpc.history = {} 
	end
	if questid then
		local quest, zone = self:GetQuestData(questid, category)
		self:Debug("AddQuest - questid:"..concat(questid) .. " zone:"..concat(zone))
		if quest == false then
			return false
		end
		if zone ~= nil then
			if dbpc.history[zone] == nil then
				dbpc.history[zone] = {}
			end
			if quest ~= nil then
				if dbpc.history[zone][questid] == nil then
					dbpc.history[zone][questid] = {}
					dbpc.history[zone][questid].id = questid
					dbpc.history[zone][questid].status = 0
				end
				self:UpdateFrame()
				return zone, quest.d
			else
				return false
			end
		else
			self:UpdateFrame()
			return false
		end
	end
end

function addon:UpdateFrame()
	local zonename
	_, zonename = self:GetCategory(zoneid)
	UIDropDownMenu_SetText(EQDropdown, zonename)
	if EveryQuestFrame:IsShown() then
		local buttonid = 1
		local controli = 0
		questlist = self:GetZoneQuestData(zonegroup, zoneid)
		local questcount = 0
		local historylist = {}
		if questlist then
			for k, quest in pairs (questlist) do
				if quest.s then
					if quest.s == faction or quest.s == 3 then
						if db.view == "history" then
							if dbpc.history[zoneid] ~= nil and dbpc.history[zoneid][quest.id] ~= nil then
								questcount = questcount +1
							end
						else
							questcount = questcount +1
						end
					end
				end
			end
		end
		if questcount > 0 then
			sort(questlist, function(a,b) return self:SortTable(a,b) end)
		end
		FauxScrollFrame_Update(EveryQuestListScrollFrame,questcount,27,16)
		local scrolloffset = FauxScrollFrame_GetOffset(EveryQuestListScrollFrame)
		local quest
		if questcount then
			if questlist then
				for uid, quest in pairs (questlist) do
					if quest["s"] then
						if quest["s"] == faction or quest["s"] == 3 or quest.s == 0 then
							--self:Debug("UpdateFrame - questid:"..concat(quest.id) .. " - side:" ..concat(quest.s).. " - zoneid:"..zoneid)
							if db.view == "history" then
								if dbpc.history[zoneid] and dbpc.history[zoneid][quest.id] then
									controli = controli + 1
									if controli > scrolloffset then
										if buttonid > 27 then 
											break 
										end
										if dbpc.history[zoneid] ~= nil and dbpc.history[zoneid][uid] ~= nil then
											quest.completed = dbpc.history[zoneid][uid].completed
											quest.abandoned = dbpc.history[zoneid][uid].abandoned
											quest.status = dbpc.history[zoneid][uid].status
										end
										self:UpdateButton(buttonid, quest, uid)
										buttonid = buttonid +1		
									end
								end
							else
								controli = controli + 1
								if controli > scrolloffset then
									if buttonid > 27 then 
										break 
									end
									if dbpc.history[zoneid] ~= nil and dbpc.history[zoneid][uid] ~= nil then
										quest.completed = dbpc.history[zoneid][uid].completed
										quest.abandoned = dbpc.history[zoneid][uid].abandoned
										quest.status = dbpc.history[zoneid][uid].status
									end
									self:UpdateButton(buttonid, quest, uid)
									buttonid = buttonid +1		
								end
							end
						end
					end
				end
			end
		end
		for j = buttonid, 27 ,1 do
			button = getglobal("EveryQuestTitle"..j)
			button:Hide()
		end
	end
end

-- Get a Quest Data from a LOD module and return the table and the Category
function addon:GetQuestData(questid, category, questname, zid)
	self:Debug("GetQuestData - questid:"..concat(questid).." category:"..concat(category))
	local zg
	if zid == nil then
		for k,v in pairs(zonemenu) do -- for each top level category
			--self:Debug("forloop: zonemenu -- "..k .. " - " .. concat(v))
			if k == category then
				zg = k
				zid = nil
			else
				for ak,av in pairs(v) do -- for each category
					--self:Debug("forloop: zonemenu category -- "..concat(ak) .. " - " .. concat(av[2]))
					if av[2] == category then
						if zg == nil then
							zg = k
							zid = av[1]
						end
					end
				end
			end
		end
	end
	if zg == nil and zid ~= nil then
		zg = self:GetCategory(zid)
	end
	self:Debug("GetQuestData - zonegroup:"..concat(zg).." zoneid:"..concat(zid))
	if zg ~= nil and zid ~= nil then
		self:Debug("1GetQuestData - zonegroup:"..concat(zg).." zoneid:"..concat(zid))
		quests = self:GetZoneQuestData(zg, zid)
		if quests == false then
			self:Debug("GetQuestData(): No quests, returning false")
			return false
		end
		for k,quest in pairs(quests) do
			--for kt,vt in pairs(quest) do self:Print(kt .. " - " .. vt) end
			if quest.id == questid then
				--if self.db.char.history[zoneid] and self.db.char.history[zoneid][questid] then
					--self:Debug("GetQuestData - from history - questid:"..concat(questid).." zonegroup:"..concat(zonegroup).." zoneid:"..concat(zoneid))
					--return self.db.char.history[zoneid][questid], zoneid
				--else
					self:Debug("GetQuestData - from data - questid:"..concat(questid).." zonegroup:"..concat(zg).." zoneid:"..concat(zid))
					return quest, zid
				--end
			end
			if quest.n == questname then
				self:Debug("GetQuestData - from data - questid:"..concat(questid).." zonegroup:"..concat(zg).." zoneid:"..concat(zid))
				return quest, zid
			end
		end
	end
	self:Debug("GetQuestData(): Try an expanded search")
	-- try an expanded search
	if zg ~= nil then
		local moduledata = self:LoadQuestData(zg)
		if moduledata == false then
			return false
		end
		for k,part in pairs(moduledata) do
			for kt,quest in pairs(part) do
				--for kt,vt in pairs(quest) do self:Print(kt .. " - " .. vt) end
				if quest.id == questid then
					zid = k
					self:Debug(k)
					--if self.db.char.history[zoneid] and self.db.char.history[zoneid][questid] then
						--self:Debug("GetQuestData (Expanded) - from history - questid:"..concat(questid).." zonegroup:"..concat(zonegroup).." zoneid:"..concat(zoneid))
						--return self.db.char.history[zoneid][questid], zoneid
					--else
						self:Debug("GetQuestData (Expanded) - from data - questid:"..concat(questid).." zonegroup:"..concat(zg).." zoneid:"..concat(zid))
						return quest, zid
					--end
				end
				if quest.n == questname then
					zid = k
					self:Debug("GetQuestData (Expanded) - from data - questid:"..concat(questid).." zonegroup:"..concat(zg).." zoneid:"..concat(zid))
					return quest, zid
				end
			end
		end
	end
	self:Debug("Expanded Search")
	--groups = {"Battlegrounds", "Classes", "Dungeons", "Kalimdor", "Eastern Kingdoms", "Miscellaneous", "Outland", "Professions", "Raids", "Seasonal"}
	local moduledata
	for group,_ in pairs(zonemenu) do
		moduledata = self:LoadQuestData(group)
		if moduledata ~= false then
			for k,part in pairs(moduledata) do
				for kt,quest in pairs(part) do
					--for kt,vt in pairs(quest) do self:Print(kt .. " - " .. vt) end
					if quest.id == questid then
						zid = k
						--if self.db.char.history[k] and self.db.char.history[k][questid] then
						--	self:Debug("GetQuestData (Expanded 2x) - from history - questid:"..concat(questid).." zonegroup:"..concat(v).." zoneid:"..concat(k))
						--	return self.db.char.history[k][questid], k
						--else
							self:Debug("GetQuestData (Expanded 2x) - from data - questid:"..concat(questid).." zonegroup:"..concat(v).." zoneid:"..concat(zid))
							return quest, zid
						--end
					end
					if quest.n == questname then
						zid = k
						self:Debug("GetQuestData (Expanded 2x) - from data - questid:"..concat(questid).." zonegroup:"..concat(zg).." zoneid:"..concat(zid))
						return quest, zid
					end
				end
			end
		end
	end
		
	return false
end

function addon:UpdateButton(buttonid, quest, uid)
	if db.view == "history" or db.view == "zone" then
		local button = getglobal("EveryQuestTitle"..buttonid)
		button:SetNormalTexture("")
		button:SetText("")
		if not questdisplay[buttonid] then
			if dbpc.history[zoneid] and dbpc.history[zoneid][quest.id] then
				questdisplay[buttonid] = dbpc.history[zoneid][quest.id]
			else
				questdisplay[buttonid] = quest
			end
		end
		if questdisplay[buttonid].id ~= quest.id then
			questdisplay[buttonid] = nil
			if dbpc.history[zoneid] and dbpc.history[zoneid][quest.id] then
				questdisplay[buttonid] = dbpc.history[zoneid][quest.id]
			else
				questdisplay[buttonid] = quest
			end
		end
		--questdisplay[buttonid].arrayid = arrayid
		if quest.t then
			--self:Debug("questtype:"..quest.t)
			qTag = self:QuestType(quest.t)
		else
			qTag = ""
		end
		if quest.d then
			--if qTag == nil then qTag = "" end
			qTag = qTag .. L["Y"]
		end
		local level
		if quest.l then
			level = quest.l
		else 
			if quest.r then
				level = "r"..quest.r
			else
				level = "--"
			end
		end
		button:SetText("["..level..qTag.."] "..quest.n)
		if dbpc.history[zoneid] and dbpc.history[zoneid][quest.id] then
			local qhistory = dbpc.history[zoneid][quest.id]
			if qhistory.status ~= nil then
				--self:Debug(history["status"] .. " - " .. history["id"])
				button:SetNormalFontObject(TextColors["s"..qhistory["status"]].font)
			else
				button:SetNormalFontObject(TextColors["unknown"].font)
			end
		else
			button:SetNormalFontObject(TextColors["unknown"].font)
		end
		button:Show()
	end
end

function addon:ButtonEnter()
	local index = this:GetID()
	local isCollected = false
	local quest = questdisplay[index]
	local zoneid = zoneid
	local uid = quest.id
	GameTooltip_SetDefaultAnchor(GameTooltip, this)
	GameTooltip:SetHyperlink("quest:"..uid)
	local queststatus = "Unknown"
	local status = 99
	if dbpc.history[zoneid] and dbpc.history[zoneid][uid] then
		isCollected = true
		if dbpc.history[zoneid][uid].status then
			--self:Debug("ButtonEnter - in history buttonid:"..index.." zoneid:"..zoneid.." questid:"..questid)
			status = dbpc.history[zoneid][uid].status
			if status == -1 then
				queststatus = L["Failed or Abandoned"]
			elseif status == 0 then
				queststatus = L["In Progress"]
			elseif status == 1 then
				queststatus = L["Completed"]
			elseif status == 2 then
				queststatus = L["Turned In"]
			end
		end
	end
	GameTooltip:AddLine(" ", self:GetColor("FFFFFF"))
	--self:Debug("ButtonEnter - buttonid:"..index.." queststatus:"..queststatus.." status:"..status)
	GameTooltip:AddLine(L["Status: "] .. queststatus,self:GetColor(status))
	if isCollected then
		if dbpc.history[zoneid][uid].completed then
			completedline = L["Completed"]
			if dbpc.history[zoneid][uid].count then
				completedline = completedline .. " ("..dbpc.history[zoneid][uid].count.." "..L["Times"]..")"
			end
			completedline = completedline .. ": "..self:timeDiff(dbpc.history[zoneid][uid].completed)
			GameTooltip:AddLine(completedline,self:GetColor("FFFFFF"))
			
		else
			if dbpc.history[zoneid][uid].failed then
				GameTooltip:AddLine(L["Failed: "] .. self:timeDiff(dbpc.history[zoneid][uid].failed),self:GetColor("FFFFFF"))
			end
			if dbpc.history[zoneid][uid].abandoned then
				GameTooltip:AddLine(L["Abandoned: "] .. self:timeDiff(dbpc.history[zoneid][uid].abandoned),self:GetColor("FFFFFF"))
			end
		end
	end
	GameTooltip:Show()
end

function addon:ButtonClick(button)
	clickedID = this:GetID()
	local questname, questlevel
	local quest = questdisplay[clickedID]
	if button == "LeftButton" then
		if ( IsModifiedClick() ) then
			if ( IsModifiedClick("CHATLINK") and ChatFrameEditBox:IsVisible() ) then
				local questinfo = self:GetQuestData(quest.id, nil, nil, zoneid)
				questname = quest.n or questinfo.n or L["Unknown"]
				questlevel = quest.l or questinfo.l or 1
				local questLink = self:CreateQuestLink(quest.id, questname, questlevel);
				if ( questLink ) then
					ChatEdit_InsertLink(questLink);
				end
			end
		else
			-- open lightheaded if enabled
			if IsAddOnLoaded("Lightheaded") then
				if IsAddOnLoaded("beql") then
					beql:Minimize()
				end
				
				QuestLogFrame:Show()
				LightHeaded:UpdateFrame(quest.id, 1)
				QuestLogFrame:ClearAllPoints()
				QuestLogFrame:SetPoint("TOPLEFT",EveryQuestFrame, "TOPLEFT", 360, 0)
			end
			if quest.status == 0 then
				Quixote:ShowQuestLog(quest.id)
				QuestLogFrame:ClearAllPoints()
				QuestLogFrame:SetPoint("TOPLEFT",EveryQuestFrame, "TOPLEFT", 360, 0)
			end
		end
	elseif button == "RightButton" then
		-- open quest menu
		ToggleDropDownMenu(1, nil, EveryQuest_QuestMenu, this:GetName(), 0, 0)
	end
end

function addon:GetStatus(displayid, queststatus)
	--self:Debug("GetStatus - did:"..concat(displayid)..", status:"..concat(queststatus))
	if questdisplay[displayid].status and questdisplay[displayid].status == queststatus then
		return true
	else
		return false
	end
end

function addon:UpdateStatus(displayid, queststatus)
	--questdisplay[displayid]
	local quest = questdisplay[displayid]
	local uid = quest.id
	if not dbpc.history[zoneid] then
		dbpc.history[zoneid] = {}
	end
	if not dbpc.history[zoneid][uid] then
		dbpc.history[zoneid][uid] = {}
		dbpc.history[zoneid][uid].id = uid
	end
	dbpc.history[zoneid][uid].status = queststatus
	self:UpdateFrame()
end

function addon:SortTable(a,b)
	sorta = a
	sortb = b
	
	if sorta.d == nil then adaily = 0 else adaily = sorta.d end
	if sortb.d == nil then bdaily = 0 else bdaily = sortb.d end
	if sorta.t == nil then atype = 9999 else atype = sorta.t end
	if sortb.t == nil then btype = 9999 else btype = sortb.t end
	if sorta.l == nil then if sorta.r == nil then alevel = 0 else alevel = sorta.r end else alevel = sorta.l end
	if sortb.l == nil then if sortb.r == nil then blevel = 0 else blevel = sortb.r end else blevel = sortb.l end
	if adaily == bdaily then
		if atype == btype then
			if (alevel == blevel) then-- or (alevel == d.r) or (c.r == d.r) or (c.r == d.r) then
				if sorta.n == sortb.n then
					return false
				elseif sorta.n < sortb.n then
					return true
				elseif sorta.n > sortb.n then
					return false
				end
			elseif alevel > blevel then
				return true
			elseif alevel < blevel then
				return false
			end
		elseif atype < btype then
			return true
		elseif btype > atype then
			return false
		end
	elseif adaily > bdaily then
		return true
	elseif adaily < bdaily then
		return false
	end
end

function addon:PLAYER_LOGIN()
	self:UnregisterEvent("PLAYER_LOGIN")
	self:Debug("Player_Login")
	self:ZONE_CHANGED_NEW_AREA()
	-- If the quest log has been scaled, lets scale our frame to match
	EveryQuestFrame:SetScale(QuestLogFrame:GetScale())
	
	-- Optional launcher support for LDB-1.1 if present, this code is placed here so
	-- that it runs after all other addons have loaded since we don't embed LDB-1.1
	if LibStub("LibDataBroker-1.1", true) and not IsAddOnLoaded("Broker2FuBar") then
		local LDB = LibStub("LibDataBroker-1.1", true)
		local launcher = LDB:NewDataObject("EveryQuest", {
		    type = "launcher",
		    icon = "Interface\\AddOns\\EveryQuest\\icon",
		    OnClick = function(clickedframe, button)
				if button == "RightButton" then addon:ShowConfig() else addon:Toggle() end
			end,
		})
	end
end

function addon:List(value)
	--self:Debug("List()")
	if value == "toggle" then
		if db.view == "zone" then value = "history" elseif db.view == "history" then value = "zone" end
	end
	if value == nil then
		if db.view ~= nil then
			value = db.view
		else
			value = "history"
		end
	end
	if value == "history" then
		db.view = "history"
		self:Debug("ListToggle(history)")
		addon.frames.Toggle:SetText("Show Zone Quests")
		self:NewZone()
	elseif value == "zone" then
		db.view = "zone"
		self:Debug("ListToggle(zone)")
		addon.frames.Toggle:SetText("Show Quest History")
		self:NewZone()
	end
end

function addon:GetZoneQuestData(zonegroup, zoneid)
	groupdata = self:LoadQuestData(zonegroup)
	if groupdata ~= false then
		return groupdata[zoneid]
	else
		return false
	end
	return false
end

function addon:LoadQuestData(group)
	if group ~= nil then
		local varname = "EveryQuest_"..gsub(group, " ", "_")
		--self:Debug("Loading single module: "..concat(varname))
		local _, _, _, enabled = GetAddOnInfo(varname)
		if not EveryQuestData[group] then
			
			--self:Debug("Module "..concat(group).." not loaded")
			if enabled then
				self:Print(L["Loading "] .. group .. L[" Quest Data"])
				local succ,reason = LoadAddOn(varname)
				if succ ~= 1 then
					self:Print(L["Could not load "] .. group .. L[" Quest Data"], reason)
					return false
				end
				collectgarbage("collect")
			else
				self:Print(L["Requires LOD Module: "] .. varname)
				return false
			end
		else
			--self:Debug("Module "..concat(group).." is loaded")
		end
		return EveryQuestData[group] --questdata[varname] and varname
	else
		
	end
	return false
end

function addon:NewZone()
	if zoneid ~= nil and zonegroup ~= nil then
		self:Debug("NewZone view:"..concat(db.view).." zoneid:"..concat(zoneid).." zonegroup:"..concat(zonegroup))
		EveryQuestListScrollFrame:SetVerticalScroll(0)
		self:UpdateFrame()
	else
		self:Debug("NewZone - zoneid and zonegroup are empty")
	end
end

function addon:GetColor(hex)
	if hex == 1 then
		return 0,1,0
	elseif hex == -1 then
		return 1,0,0
	elseif hex == 2 then
		return 0,.807,.019
	elseif hex == 0 then
		return 1,1,0
	elseif hex == 99 then -- Unknown
		return 1,1,1
	end
	local rhex, ghex, bhex = string.sub(hex, 1, 2), string.sub(hex, 3, 4), string.sub(hex, 5, 6)
	return tonumber(rhex, 16)/255, tonumber(ghex, 16)/255, tonumber(bhex, 16)/255
end

function addon:CreateQuestLink(questid, questname, questlevel)
	if questlevel == nil then questlevel = 1 end
	self:Debug("CreateQuestLink - quest:"..concat(questid)..":"..concat(questlevel))
	return "\124cffffff00\124Hquest:"..questid..":"..questlevel.."\124h["..questname.."]\124h\124r"
end

function EveryQuest_ScrollFrame_Update()
	addon:UpdateFrame()
end

function addon:timeDiff(timestamp)
    local now = time()
	local amount = now - timestamp
	local value
	local seconds, minutes, hours, days
    --If the difference is positive "ago" - negative "away"

	--amount = amount + DAY + HOUR*5
	
	if amount >= (DAY * 10) then
		return date("%m/%d/%y %I%p", timestamp)
	end
	
	if (amount >= DAY) and (amount < (DAY * 10)) then
		-- between one day and 30 days
		days = math.floor(amount/DAY)
		if days ~= 1 then days = days .. L[" days "] else days = days .. L[" day "] end
		hours = amount%DAY
		hours = math.floor(hours/HOUR)
		if hours ~= 0 then hours = hours .. L[" hr "] else hours = "" end
		return days .. hours .. L["ago"]
		--return "between one day and 30 days"
	end
  
	if (amount < DAY) and (amount >= HOUR) then
		-- between one hour and one day
		--value = string.format("%H hr %M min ago", amount)
		hours = math.floor(amount/HOUR)
		minutes = amount%HOUR
		minutes = math.floor(minutes/MINUTE +.5)
		if minutes ~= 0 then minutes = minutes .. L[" min "] else minutes = "" end
		return hours .. L[" hr "] .. minutes .. L["ago"]
		--return  .. " between one hour and one day"
	end
	
	if (amount < HOUR and amount >= MINUTE) then
		-- between one minute and one hour
		if self:round(amount / MINUTE) > 1 then
			return self:round(amount / MINUTE) .. L[" minutes ago"]
		else
			return L["1 minute ago"]
		end
	end
	
	if amount > 1 then
		return amount .. L[" seconds ago"]
	else
		return amount .. L[" second ago"]
	end
end

function addon:round(num, idp)
	local mult = 10^(idp or 0)
	return math.floor(num * mult + 0.5) / mult
end

function addon:QuestType(qtype)
	if qtype == 1 then
		return L["G"], L["Group"]
	elseif qtype == 62 then
		return L["R"], L["Raid"]
	elseif qtype == 85 then
		return L["H"], L["Heroic"]
	elseif qtype == 81 then
		return L["D"], L["Dungeon"]
	elseif qtype == 41 then
		return L["P"], L["PvP"]
	end
end

--- EOF ---